
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>网络之NSURLSession / iVAN</title>

    <meta name="description" content="网络之NSURLSession NSUrlSession参考的这篇博客,自己也调试了它的代码:http://www.it165.net/pro/html/201406/15223.html ,对NSUrlSession还不太理解,先记下笔记,随后慢慢消化 AppDelegate.h // // AppDelegate.h // NSUrlSession // // Created by City--Online on 15/4/27. // Copyright (c) 2015年 CYW. All rights reserve">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">网络之NSURLSession</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>NSUrlSession参考的这篇博客,自己也调试了它的代码:http://www.it165.net/pro/html/201406/15223.html ,对NSUrlSession还不太理解,先记下笔记,随后慢慢消化</p>
<p>AppDelegate.h</p>
<pre><code>//
//  AppDelegate.h
//  NSUrlSession
//
//  Created by City--Online on 15/4/27.
//  Copyright (c) 2015年 CYW. All rights reserved.
//

#import &lt;UIKit/UIKit.h&gt;
typedef void(^MyBlock)();
@interface AppDelegate : UIResponder &lt;UIApplicationDelegate&gt;
@property (strong, nonatomic) UIWindow *window;
@property (copy, nonatomic) MyBlock backgroundURLSessionCompletionHandler;

@end</code></pre>
<p> AppDelegate.m</p>
<pre><code>- (void)application:(UIApplication *)application handleEventsForBackgroundURLSession:(NSString *)identifier completionHandler:(void (^)())completionHandler{

    self.backgroundURLSessionCompletionHandler = completionHandler;
}</code></pre>
<p> ViewController.m</p>
<pre><code>//
//  ViewController.m
//  NSUrlSession
//
//  Created by City--Online on 15/4/27.
//  Copyright (c) 2015年 CYW. All rights reserved.
//

#import "ViewController.h"
#import "AppDelegate.h"

@interface ViewController ()&lt;NSURLSessionDelegate&gt;
@property (nonatomic,strong)UIImageView *imageView;
@property (nonatomic,strong)UIProgressView *progressIndicator;

@property (nonatomic,strong)NSURLSession *urlSession;         //  普通会话
//@property (nonatomic,strong)NSURLSession *backgroundSession;  //  后台会话
@property (nonatomic,strong)NSURLSessionDownloadTask *sessionDownloadTask;  //  下载Task
@property (nonatomic,strong)NSURLSessionDownloadTask *resumableTask;        //  恢复下载Task
@property (nonatomic,strong)NSURLSessionDownloadTask *backgroundTask;       //  后台下载Task
@property (nonatomic,strong)NSData *partialData;   //  下载的局部数据

@end

@implementation ViewController

- (void)viewDidLoad{

    [super viewDidLoad];

    self.imageView = [[UIImageView alloc] initWithFrame:CGRectMake(0, 64, 320, 300)];
    [self.view addSubview:_imageView];

    self.progressIndicator = [[UIProgressView alloc] initWithProgressViewStyle:UIProgressViewStyleDefault];
    _progressIndicator.frame = CGRectMake(50, 500, 220, 50);
    [self.view addSubview:_progressIndicator];

    UIButton *cancleButton = [UIButton buttonWithType:UIButtonTypeSystem];
    cancleButton.frame = CGRectMake(120, 400, 40, 40);
    [cancleButton setTitle:@"取消" forState:UIControlStateNormal];
    [cancleButton addTarget:self action:@selector(didClickCancleButtonAction:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:cancleButton];

    UIButton *downloadButton = [UIButton buttonWithType:UIButtonTypeSystem];
    downloadButton.frame = CGRectMake(20, 400, 40, 40);
    [downloadButton setTitle:@"下载" forState:UIControlStateNormal];
    [downloadButton addTarget:self action:@selector(didClickDownloadButtonAction:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:downloadButton];

    UIButton *uploadButton = [UIButton buttonWithType:UIButtonTypeSystem];
    uploadButton.frame = CGRectMake(70, 400, 40, 40);
    [uploadButton setTitle:@"上传" forState:UIControlStateNormal];
    [uploadButton addTarget:self action:@selector(didClickUploadButtonAction:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:uploadButton];

    UIButton *resumableButton = [UIButton buttonWithType:UIButtonTypeSystem];
    resumableButton.frame = CGRectMake(180, 400, 40, 40);
    [resumableButton setTitle:@"恢复" forState:UIControlStateNormal];
    [resumableButton addTarget:self action:@selector(didClickResuableButtonAction:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:resumableButton];

    UIButton *backgroundLoadButton = [UIButton buttonWithType:UIButtonTypeSystem];
    backgroundLoadButton.frame = CGRectMake(220, 400, 80, 40);
    [backgroundLoadButton setTitle:@"后台下载" forState:UIControlStateNormal];
    [backgroundLoadButton addTarget:self action:@selector(didClickBackgroundButtonAction:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:backgroundLoadButton];

#pragma mark - 如果我们需要利用NSURLSession进行数据传输我们需要：
    /**
     *  创建一个NSURLSessionConfiguration，用于创建NSSession时设置工作模式(3种)
     *  (1)一般模式（default）：工作模式类似于原来的NSURLConnection，可以使用缓存的Cache，Cookie，鉴权。
     *  (2)及时模式（ephemeral）：不使用缓存的Cache，Cookie，鉴权。
     *  (3)后台模式（background）：在后台完成上传下载，创建Configuration对象的时候需要给一个NSString的ID用于追踪完成工作的Session是哪一个
     */
    NSURLSessionConfiguration *sessionConfig = [NSURLSessionConfiguration defaultSessionConfiguration];

    /**
     *  @网络设置：参考NSURLConnection中的设置项
     *  两种创建方法(目前不太懂什么区别)
     *  (1)就是根据刚才创建的Configuration创建一个Session，系统默认创建一个新的OperationQueue处理Session的消息
     *  (2)可以设定回调的delegate（注意这个回调delegate会被强引用），并且可以设定delegate在哪个OperationQueue回调，如果我们将其
     *     设置为[NSOperationQueue mainQueue]就能在主线程进行回调非常的方便
     */
    //NSURLSession *session = [NSURLSession sessionWithConfiguration:sessionConfig];
    self.urlSession = [NSURLSession sessionWithConfiguration:sessionConfig delegate:self delegateQueue:[NSOperationQueue currentQueue]];
    NSURL *url = [NSURL URLWithString:@"http://assets.sbnation.com/assets/2512203/dogflops.gif"];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];

    /**
     *  NSURLSessionUploadTask：上传用的Task，传完以后不会再下载返回结果；
     *  NSURLSessionDownloadTask：下载用的Task；
     *  NSURLSessionDataTask：可以上传内容，上传完成后再进行下载。
     */
    self.sessionDownloadTask = [self.urlSession downloadTaskWithRequest:request];

    //  同NSURLConnection一样,有代理方法也就有block方法
    //    [session dataTaskWithRequest:request completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
    //    }];

}

#pragma mark 点击下载
- (void)didClickDownloadButtonAction:(UIButton *)button{

    // 因为任务默认是挂起状态，需要恢复任务（执行任务）
    [_sessionDownloadTask resume];

}

#pragma mark 点击上传
- (void)didClickUploadButtonAction:(UIButton *)button{

    //判断imageView是否有内容
    if (_imageView.image == nil) {

        NSLog(@"image view is empty");
        return;

    }

    // 0. 上传之前在界面上添加指示符
    UIActivityIndicatorView *indicator = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleGray];
    // 设置位置???
    CGSize size = _imageView.bounds.size;
    indicator.center = CGPointMake(size.width / 2.0, size.height / 2.0);
    [self.imageView addSubview:indicator];
    [indicator startAnimating];

    // 1. URL
    NSURL *url = [NSURL URLWithString:@"http://assets.sbnation.com/assets/2512203/dogflops.gif"];

    // 2. Request -&gt; PUT,request的默认操作是GET
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:5.0f];
    request.HTTPMethod = @"PUT";

    // *** 设置网络请求的身份验证! ***

    // 1&gt; 授权字符串

    NSString *authStr = @"admin:123456";

    // 2&gt; BASE64的编码,避免数据在网络上以明文传输
    // iOS中,仅对NSData类型的数据提供了BASE64的编码支持
    NSData *authData = [authStr dataUsingEncoding:NSUTF8StringEncoding];
    NSString *encodeStr = [authData base64EncodedStringWithOptions:NSDataBase64EncodingEndLineWithCarriageReturn];
    NSString *authValue = [NSString stringWithFormat:@"Basic %@", encodeStr];
    [request setValue:authValue forHTTPHeaderField:@"Authorization"];

    // 3. Session
    NSURLSessionConfiguration *sessionConfig = [NSURLSessionConfiguration defaultSessionConfiguration];

    NSURLSession *session = [NSURLSession sessionWithConfiguration:sessionConfig delegate:self delegateQueue:[NSOperationQueue mainQueue]];

    // 4. UploadTask
    NSData *imageData = UIImageJPEGRepresentation(_imageView.image, 0.75);
    //  应用block的请求方式
    NSURLSessionUploadTask *uploadTask = [session uploadTaskWithRequest:request fromData:imageData completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {

        // 上传完成后,data参数转换成string就是服务器返回的内容

        NSString *str = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
        NSLog(@"OK -&gt; %@", str);

        [NSThread sleepForTimeInterval:5.0f];

        dispatch_async(dispatch_get_main_queue(), ^{

            [indicator stopAnimating];
            [indicator removeFromSuperview];

        });

    }];

    // 因为任务默认是挂起状态，需要恢复任务（执行任务）
    [uploadTask resume];
}

#pragma mark 点击取消
//  NSURLConnection一旦发送是没法取消的。但是，我们可以很容易的取消掉一个NSURLSessionTask任务
- (void)didClickCancleButtonAction:(UIButton *)button{

    /**
     *  当取消后，会回调这个URLSession:task:didCompleteWithError:代理方法，通知你去及时更新UI。当取消一个任务后，也
     *  十分可能会再一次回调这个代理方法URLSession:downloadTask:didWriteData:BytesWritten:totalBytesExpectedToWrite:
     *  当然，didComplete 方法肯定是最后一个回调的。
     */
        if (_sessionDownloadTask) {

            //  取消下载请求
            [_sessionDownloadTask cancel];
            _sessionDownloadTask = nil;
        }

    if (!self.sessionDownloadTask) {

        //  停止下载任务,把待恢复的数据保存到一个变量中，方便后面恢复下载使用
        [self.sessionDownloadTask cancelByProducingResumeData:^(NSData *resumeData) {

            self.partialData = resumeData;

            self.sessionDownloadTask = nil;

        }];
    }
}

#pragma mark  恢复下载(断点续传)
- (void)didClickResuableButtonAction:(UIButton *)button{

    if (self.partialData) {

        self.sessionDownloadTask = [self.urlSession downloadTaskWithResumeData:self.partialData];
        self.partialData = nil;

    }else{

        NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:@"http://assets.sbnation.com/assets/2512203/dogflops.gif"]];
        self.resumableTask = [self.urlSession downloadTaskWithRequest:request];

    }

    [self.sessionDownloadTask resume];

}

#pragma mark 后台下载模式
- (void)didClickBackgroundButtonAction:(UIButton *)button{

    NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:@"http://assets.sbnation.com/assets/2512203/dogflops.gif"]];
                                                          self.backgroundTask = [[self backgroundSession] downloadTaskWithRequest:request];

                                                          [self.backgroundTask resume];
                                                          }

#pragma mark - NSURLSessionDownloadTaskDelegate
//  下载完成
- (void)URLSession:(NSURLSession *)session downloadTask:(NSURLSessionDownloadTask *)downloadTask didFinishDownloadingToURL:(NSURL *)location{

  /**
   *******-&gt;appDelegete里面的方法
   typedef void(^MyBlock)();
   @property (copy, nonatomic) MyBlock backgroundURLSessionCompletionHandler;
   //  后台请求结束时调用的方法
   - (void)application:(UIApplication *)application handleEventsForBackgroundURLSession:(NSString *)identifier completionHandler:(void (^)())completionHandler{

   self.backgroundURLSessionCompletionHandler = completionHandler;
   }

   */
  //  如果是后台NSURLSession,后台请求结束后会调用这个方法,通知你应该更新UI了
  if (session == [self backgroundSession]) {

      self.backgroundTask = nil;
      AppDelegate *appDelegate = (AppDelegate *)[UIApplication sharedApplication].delegate;
      if (appDelegate.backgroundURLSessionCompletionHandler) {
          void(^handler)() = appDelegate.backgroundURLSessionCompletionHandler;
          appDelegate.backgroundURLSessionCompletionHandler = nil;
          handler();
      }

  }

  //  这里的缓存处理做的不好,大家按自己的方法处理就行,还有图片的存储以它本身的URL路径为准,这样是不会有重复的
  NSFileManager *fileManager = [NSFileManager defaultManager];
  NSURL *cachesURLPath = [[fileManager URLsForDirectory:NSCachesDirectory inDomains:NSUserDomainMask] lastObject];
  //  根据URL获取到下载的文件名,拼接成沙盒的存储路径(location是下载的临时文件目录,在tmp文件夹里面)
  NSURL *destinationPath = [cachesURLPath URLByAppendingPathComponent:[location lastPathComponent]];

  NSError *error = nil;
  BOOL success = [fileManager moveItemAtURL:location toURL:destinationPath error:&amp;error];
  [fileManager removeItemAtURL:location error:NULL];

  //  location是下载的临时文件目录,将文件从临时文件夹复制到沙盒
  //    BOOL success = [fileManager copyItemAtURL:location toURL:destinationPath error:&amp;error];
  if (success) {

      dispatch_async(dispatch_get_main_queue(), ^{

          UIImage *image = [UIImage imageWithContentsOfFile:[destinationPath path]];
          self.imageView.image = image;
          //  UIImageView会自动裁剪图片适应它的frame,下面这个属性就是展示原图
          self.imageView.contentMode = UIViewContentModeScaleAspectFill;

      });
  }

}

//  不管任务是否成功，在完成后都会回调这个代理方法
- (void)URLSession:(NSURLSession *)session task:(NSURLSessionTask *)task didCompleteWithError:(NSError *)error{

  //  如果error是nil，则证明下载是成功的，否则就要通过它来查询失败的原因。如果下载了一部分，这个error会包含一个NSData对象，如果后面要恢复任务可以用到
  if (error == nil) {

      dispatch_async(dispatch_get_main_queue(), ^{

          self.progressIndicator.hidden = YES;
      });
  }

}

//  传输进度
- (void)URLSession:(NSURLSession *)session downloadTask:(NSURLSessionDownloadTask *)downloadTask didWriteData:(int64_t)bytesWritten totalBytesWritten:(int64_t)totalBytesWritten totalBytesExpectedToWrite:(int64_t)totalBytesExpectedToWrite{

  double currentValue = totalBytesWritten / (double)totalBytesExpectedToWrite;
  dispatch_async(dispatch_get_main_queue(), ^{
      NSLog(@"%f",currentValue);
      self.progressIndicator.hidden = NO;
      self.progressIndicator.progress = currentValue;
  });
}

//  未知
- (void)URLSession:(NSURLSession *)session downloadTask:(NSURLSessionDownloadTask *)downloadTask didResumeAtOffset:(int64_t)fileOffset expectedTotalBytes:(int64_t)expectedTotalBytes{

}

#pragma mark - NSURLSession另一个重要的特性：即使当应用不在前台时，你也可以继续传输任务。当然，我们的会话模式也要为后台模式
- (NSURLSession *)backgroundSession{

  //  通过给的后台token，我们只能创建一个后台会话，所以这里使用dispatch once block
  static NSURLSession *backgroundSession = nil;
  static dispatch_once_t onceToken;
  dispatch_once(&amp;onceToken, ^{
      NSURLSessionConfiguration *config=[NSURLSessionConfiguration backgroundSessionConfigurationWithIdentifier:@"com.shinobicontrols.BackgroundDownload.BackgroundSession"];
//      NSURLSessionConfiguration *config = [NSURLSessionConfiguration backgroundSessionConfiguration:@"com.shinobicontrols.BackgroundDownload.BackgroundSession"];
      backgroundSession = [NSURLSession sessionWithConfiguration:config delegate:self delegateQueue:nil];

  });

  return backgroundSession;
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end</code></pre>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nMjAxNS83MzMyMTMvMjAxNTA0LzI4MTAzODU1NDkwODE2Ny5qcGc=.jpg"></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 21:11:00</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e7%bd%91%e7%bb%9c/" title="网络">网络</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>网络之NSURLSession的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0QJWnp.html" rel="bookmark">iOS网络编程之四&mdash;&mdash;请求类NSURLRequest使用详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS网络编程之四--请求类NSURLRequest使用详解 一.引言         在前面几篇博客中,介绍了iOS开发中的网络编程相关内容并且介绍了常用了两个平行的网络框架NSURLSession和NSURLConnection.无论是NSURLSession类还是NSURLConnection类,其网络请求都是通过NSURLRequest类进行发起的,本篇博客将介绍NSURLRequest类的用法和其中请求属性的设置.         前几篇博客地址如下: 1.iOS网络框架介绍:http			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP2Xwmb.html" rel="bookmark">iOS - NetRequest   网络数据请求</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.网络请求 1.1 网络通讯三要素 1.IP 地址(主机名): 网络中设备的唯一标示.不易记忆,可以用主机名(域名). 1) IP V4: 0~255.0~255.0~255.0~255 ,共有 2^8^4 = 2^32 = 42 亿. 2) 本地回环地址: 每台机器都有自己的本地回环地址,ip 为 127.0.0.1 ,主机名为 localhost.如果 127.0.0.1 ping 不通,则网卡不正常. 本地 hosts 文件修改,终端: $ cd /etc $ sudo vim host			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7jZjz.html" rel="bookmark">iOS开发网络篇&mdash;发送GET和POST请求（使用NSURLSession）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说明: 1)该文主要介绍如何使用NSURLSession来发送GET请求和POST请求 2)本文将不再讲解NSURLConnection的使用,如有需要了解NSURLConnection如何发送请求. 详细信息,请参考:http://www.cnblogs.com/wendingding/p/3813706.html 3)本文示例代码发送的请求均为http请求,已经对info.plist文件进行配置. 如何配置,请参考:https://github.com/HanGangAndHanMeimei			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXwEP5M.html" rel="bookmark">iOS网络编程之二&mdash;&mdash;NSURLSession的简单使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS网络编程之二--NSURLSession的简单使用 一.NSURLSession简介     在iOS7之后,NSURLSession作为系统推荐使用的HTTP请求框架,在进行前台请求的情况下,NSURLSession与NSURLConnection并无太大差异,对于后台的请求,NSURLSession更加灵活的优势就将展现无遗.         1.NSURLSession集合的类型         NSURLSession类提供3中Session类型:         Default类			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6NP3yM.html" rel="bookmark">iOS开发之网络编程--1、NSURLSession的基本使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言:学习NSURLSession的使用之前,先学习一篇关于NSURLSession的好文章&lt;From NSURLConnection to NSURLSession&gt;或者是国内的译文&lt;从 NSURLConnection 到 NSURLSession&gt;,或者不用学习本人的博客园笔记直接学习&lt;从 NSURLConnection 到 NSURLSession&gt;也是可以的,这篇对NSURLSession的使用有着挺详细的论述.但是本文先粗略介绍一下NSURLSession的基			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQwlxKp.html" rel="bookmark">ios开发之Swift 使用NSURLSession通过HTTPS进行网络请求，及证书的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一,证书的生成,以及服务器配置 参考我前面写的这篇文章:Tomcat服务器配置https双向认证(使用keytool生成证书) 文章详细介绍了HTTPS,SSL/TLS.还有使用key tool生成自签名证书,Tomcat下https服务的配置.   二,iOS下APP使用HTTPS进行网络请求 1,证书导入 前面文章介绍了通过客户端浏览器访问HTTPS服务需,需要安装&quot;mykey.p12&quot;,&quot;tomcat.cer&quot;这两个证书.同样,我们开发的应用中也需要把这两个证			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqVD6ep.html" rel="bookmark">iOS - NSURLSession      网络请求</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 NS_CLASS_AVAILABLE(NSURLSESSION_AVAILABLE, 7_0) @interface NSURLSession : NSObject @available(iOS 7.0, *) public class NSURLSession : NSObject 1.NSURLSession 在 iOS9.0 之后,以前使用的 NSURLConnection 过期,苹果推荐使用 NSURLSession 来替换 NSURLConnection 完成网路请求相关操作.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMr3KOp.html" rel="bookmark">swift网络编程入门应用：天气预报</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先在Main.storyborad中添加并设置好三个label做简单的界面显示: 1 import UIKit 2 3 //1.construct a constructs 4 struct Weather { 5 var city: String? 6 var weather: String? 7 var temp: String? 8 }//为什么不实用class呢,因为结构体初始化方便,不用写初始化方法 9 10 11 12 class ViewController: UIViewCon			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ybjw15M.html" rel="bookmark">iOS开发网络篇&mdash;网络编程基础（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下面叙述的是关于几个必须要知道的iOS网络编程入门级别的要点: 1.客户端如何找到连接的服务器 客户端通过URL找到想要连接的服务器 2.什么是URL URL的全称是Uniform Resource Locator(统一资源定位符) 通过1个URL,能找到互联网上唯一的1个资源 URL就是资源的地址.位置,互联网上的每个资源都有一个唯一的URL URL的基本格式 = 协议://主机地址/路径 http://www.520it.com/img/logo.png 协议:不同的协议,代表着不同的资源查			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnX6Kb.html" rel="bookmark" class="title">桔子超强转手绘教程</a>
					<div>
						转手绘全是细活,不仅需要较强的美术功底,还需要不断练习来提高自己.尤其在处理五官及发丝的时候,需要注重高光和暗调部分的渲染,做出的效果越晶莹剔透越好. 原图 最终效果 [1] [2] [3] [4]  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8vQlb.html" rel="bookmark" class="title">个人站长需要：分享、交流、提高</a>
					<div>
						中国网络发展十几年来,个人站长起到不可磨灭的作用.现在,个人站长依旧充当中国互联网的主要力量,每天,每刻都能看到个人站长或者个人团队在网络上的创新.这样的成功不是自己的摸索,不是闭关研究实现的,而是通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7qkqM.html" rel="bookmark" class="title">用Dreamweaver轻松实现多彩的文字链接</a>
					<div>
						dreamweaver|链接 本文选自4u2v工作室编写的&lt;Dreamweaver网页设计与制作100例&gt;(人民邮电出版社出版,ISBN: 7115142394 ).未经著作权所有者书面授 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5X1BM.html" rel="bookmark" class="title">使用DatabaseMetaDate获取数据库信息</a>
					<div>
						数据|数据库   import java.sql.*;public class GetDBInfo{  public GetDBInfo()  {  }   public static void ma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ2W8M.html" rel="bookmark" class="title">揭露SEO优化高手在交换友情链接中隐藏的几个秘密</a>
					<div>
						相信站长朋友们都清楚交换友情链接的作用.网站的权重需要一定外链的积累,而友情链接在网站优化过程中外链的建设方面起着非常重要的作用.友情链接不是随便找个网站相互链接了就完事了,这其中也有不少的学问的,友 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd75eAM.html" rel="bookmark" class="title">Photoshop绘制白玫瑰插画效果</a>
					<div>
						  插画在设计中的应用不可忽视,很多优秀的设计师同时也是一位优秀的插画家,教程只是分享一些技巧和方法,创意以及表现是要慢慢积累的,本篇教程操作使用到数位板,主要内容为使用Photoshop绘制白玫瑰插 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9ER9XM.html" rel="bookmark" class="title">网页图片出现红叉怎么回事</a>
					<div>
						1.以ie浏览器为例.打开ie浏览器,然后点击工具栏上的[工具-internet选项],然后在打开的internet选项上选择[高级],这样我们在高级设置窗口上找到[多媒体]选项,然后选择[播放网页中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WdmAb.html" rel="bookmark" class="title">百度hi怎么注册？</a>
					<div>
						  百度hi怎么注册?         百度公司推出一款聊天软件--百度hi,功能都很齐全,可以帮助你找到志同道合的朋友,使用也方便.下面小乐哥分享百度hi注册图文流程详解,教大家注册一个百度hi账号 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOag6mM.html" rel="bookmark" class="title">怎么利用火绒互联防止桌面快捷方式被篡改</a>
					<div>
						  1.下载并安装火绒互联,没有安装的用户可通过上方地址下载安装,安装后打开软件. 2.在软件中找到并进入系统防护. 3.在系统防护菜单中,我们点击文件保护. 4.在文件保护菜单中,将&quot;桌面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWDmJp.html" rel="bookmark" class="title">任务管理器你看明白了吗</a>
					<div>
						  taskmgr是现在所开的这个任务管理器窗口. RTHDCPL.EXE Realtek是声卡特性设置软件相关程序. ctfmon是输入法进程. SVCHOST.exe有六个是正常的. winlog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYlOOb.html" rel="bookmark" class="title">JavaEE规范学习（一）--- JNDI</a>
					<div>
						 概述      JNDI(JavaNaming and Directory Interface,Java命名和目录接口)是SUN公司提供的一种标准的Java命名系统接口,JNDI提供统一的客户端AP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badGoJz.html" rel="bookmark" class="title">ch2-switch函数有错，执行case0后执行case1有错</a>
					<div>
						问题描述 switch函数有错,执行case0后执行case1有错 int main(){ int c; //开关控制变量 char m; //继续或退出控制变量 ALGraph G; init_AL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NNvmz.html" rel="bookmark" class="title">achartengine 折线图曲线超出Y轴，还会显示，我想让超出那部分隐藏</a>
					<div>
						问题描述 achartengine 折线图曲线超出Y轴,还会显示,我想让超出那部分隐藏 如题所述:如果不设置achartengin的MarginsColor就可以达到效果,但是我需要设置Margins ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6N63z.html" rel="bookmark" class="title">mysql-Java入门新人求助&colon;Js中表格如何实现保存删除这两个功能&quest;请举例说明</a>
					<div>
						问题描述 Java入门新人求助:Js中表格如何实现保存删除这两个功能?请举例说明 做了一个网页,具有登录功能,其中welcome.jsp为登陆成功后的页面,那么问题来了,我新建了一个表格,如何让这个表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b328YWz.html" rel="bookmark" class="title">⑳云上场景 每日瑜伽，OSS&plus;ECS组合的多网络实践</a>
					<div>
						每日瑜伽是一款全球化的综合性瑜伽导练和社交应用,该产品涵盖不同时长.不同等级的瑜伽课程,搭载高清视频.语音指导.舒缓音乐和社交功能,帮助用户乐享瑜伽,轻松交友, 旨在为大家创造一种健康的生活方式,让健 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE69G6M.html" rel="bookmark" class="title">阿里巴巴参与共建之江实验室 开展国家重大前沿基础研究</a>
					<div>
						9月6日,之江实验室在杭州举办成立大会.这一新型科研机构由浙江省政府.浙江大学.阿里巴巴集团联合共建,将以国家目标和战略需求为导向,打造一批世界一流的基础学科群,开展重大前沿基础研究和关键技术攻关,积 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVXj1b.html" rel="bookmark" class="title">Python网络协议模块学习之smtplib</a>
					<div>
						功能:smtplib模块是通过邮件服务器发送电子邮件,是smtp客户端的实现,支持邮件格式有:文本.HTML.Image.EXCEL等. 1.普通文本邮件 1 2 3 4 5 6 7 8 9 10 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK2ZRb.html" rel="bookmark" class="title">MS SQL批量生成作业脚本方法介绍总结</a>
					<div>
						在迁移或升级SQL Server数据库服务器时,很多场景下我们不能还原msdb,所以我们必须手工迁移SQL Server相关作业.如果手工生成每一个作业的脚本话,费时又费力,其实SQL Server中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94E7Rb.html" rel="bookmark" class="title">Java基础 Integer类型比较疑惑</a>
					<div>
						问题描述 Java基础 Integer类型比较疑惑 求解释,为何输出都是 true ? 感谢 public static void main(String[] args) { Integer int1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKQ7Rb.html" rel="bookmark" class="title">RTP 包格式 详细解析</a>
					<div>
						H.264 视频 RTP 负载格式 1. 网络抽象层单元类型 (NALU) NALU 头由一个字节组成, 它的语法如下:       +---------------+      |0|1|2|3|4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/zeRnm9b.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEwMDkxNzExMTc5NTg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2V0ZOR05UQTNNVGM9L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/zeRnm9b.html" rel="bookmark" class="title">栈的定义以及基本运算</a>
					<div>
						栈和队列实质上是俩种受限制的线性表 一 栈的定义: 栈(Stack)是限制仅在表的一端进行插入和删除运算的线性表. (1)通常称插入.删除的这一端为栈顶(Top),另一端称为栈底(Bottom). ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRO1Zb.html" rel="bookmark" class="title">PHP语言最新4&period;4&period;7版本于近日发布</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 PHP 是一种 CGI 程序编写语 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydEEZb.html" rel="bookmark" class="title">mysql5&period;7&period;13&period;zip安装教程（windows）&lowbar;Mysql</a>
					<div>
						这是我之前进行MySQL免安装版下载与配置的详细过程,先分享给大家. 1. 下载Mysql 官方:http://www.mysql.com→downloads→选社区版本MySQL Community ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKjR2z.html" rel="bookmark" class="title">远程控制-我要做一个远程日志抓取程序</a>
					<div>
						问题描述 我要做一个远程日志抓取程序 我要做一个远程日志抓取程序,有没有哪位可以给我个方案,大概百十台服务器,ubuntu系统,在一台机器上执行程序抓其他所有机器上符合条件的日志 解决方案 http: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYPqZp.html" rel="bookmark" class="title">郑学勤：美元回升具有世界性影响</a>
					<div>
						4月16日晚间消息 芝加哥期权交易所董事总经理郑学勤对新浪财经表示,由于美元是世界性的货币,如果美国加息后美元回升,不仅仅会影响美国经济,也会影响到其他地区依靠便宜货币来运作的大宗商品买卖,此外,对全 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjGK4M.html" rel="bookmark" class="title">Linux如何设置服务自启动&lowbar;Linux</a>
					<div>
						有时候我们需要Linux系统在开机的时候自动加载某些脚本或系统服务 主要用三种方式进行这一操作: ln -s                       在/etc/rc.d/rc*.d目录中建立/e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0j4yM.html" rel="bookmark" class="title">asp net mvc ef-asp&period;net mvc 中EF上下文的管理使用哪种方式好</a>
					<div>
						问题描述 asp.net mvc 中EF上下文的管理使用哪种方式好 1,使用取线程内唯一实例的方式管理EF上下文 2,使用 using (AceManageEntities db=new AceMan ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0ryjM.html" rel="bookmark" class="title">eval</a>
					<div>
						问题描述 各位大侠,请教下.如下,代码.&lt;td&gt;&lt;ahref='webform1.aspx?id=&lt;%#Eval(&quot;ID&quot;)%&gt;'target=&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Z13mz.html" rel="bookmark" class="title">雅虎CEO称与微软有共同利益 建议联手制定标准</a>
					<div>
						      北京时间5月10日消息,据国外媒体报道,雅虎CEO特里·塞梅尔(Terry Semel)周三在表示,在应对网络内容授权及制定网络广告业界标准上,雅虎和微软拥有共同利益并存在相同看法,双方今 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEY0WZb.html" rel="bookmark" class="title">配置-关于后台数据校验方法的问题</a>
					<div>
						问题描述 关于后台数据校验方法的问题 前段时间看到一个项目,里面的校验方式是把各个待校验的字段的校验类型在XML文件里先进行了配置,然后在检验时候,读取文件及校验类型再用反射进行字段的匹配.这样就有一 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
